#define CPU_F ((double)8000000) 
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0)) 
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0)) 

#define uchar unsigned char
#define uint  unsigned int
#define ulong unsigned long

/*BRCLK=CPU_FʱĹʽԼ㣬ҪüƵϵ*/
#define baud           9600                                //òʵĴС
#define baud_setting   (uint)((ulong)CPU_F/((ulong)baud))  //ʼ㹫ʽ
#define baud_h         (uchar)(baud_setting>>8)            //ȡλ
#define baud_l         (uchar)(baud_setting)               //λ

#define LED8PORT        P2OUT                   //P28LED
#define LED8SEL         P2SEL                   //P28LED
#define LED8DIR         P2DIR                   //P28LED

#define DATAPORT	P4OUT                   //ݿڶ˿P4
#define DATASEL         P4SEL                   //ݿڹܼĴƹģʽ
#define DATADIR         P4DIR                   //ݿڷĴ

#define CTRPORT	        P6OUT                   //ڵĶ˿P6
#define CTRSEL          P6SEL                   //ƿڹܼĴƹģʽ
#define CTRDIR          P6DIR                   //ƿڷĴ

#define DCTR0	        P6OUT &= ~BIT4          //ܶολźõ
#define DCTR1           P6OUT |=  BIT4          //ܶολźø
#define WCTR0	        P6OUT &= ~BIT3          //λλźõ
#define WCTR1           P6OUT |=  BIT3          //λλźø

#define KEYPORT	        P1OUT                   //ڵĶ˿P1
#define KEYSEL          P1SEL                   //ƿڹܼĴƹģʽ
#define KEYDIR          P1DIR                   //ƿڷĴ
#define KEYIN           P1IN                    //ɨжҪȡIO״ֵ̬

#define DACCS0          P5OUT &= ~BIT4          //DACƬѡźõ
#define DACCS1          P5OUT |=  BIT4          //DACƬѡźø
#define DIN0            P3OUT &= ~BIT1          //DAC DINܽλΪ0
#define DIN1            P3OUT |=  BIT1          //DAC DINܽλΪ1
#define DOUT0           P3OUT &= ~BIT2          //DAC DOUTܽλΪ0
#define DOUT1           P3OUT |=  BIT2          //DAC DOUTܽλΪ0
#define SCLK0           P3OUT &= ~BIT3          //DAC SCLKܽλΪ0
#define SCLK1           P3OUT |=  BIT3          //DAC SCLKܽλΪ0

#define SOUNDON         P6OUT &= ~BIT2          //
#define SOUNDOFF        P6OUT |=  BIT2          //

#define RS_CLR	        P5OUT &= ~BIT5           //RSõ
#define RS_SET	        P5OUT |=  BIT5           //RSø

#define RW_CLR	        P5OUT &= ~BIT6           //RWõ
#define RW_SET	        P5OUT |=  BIT6           //RWø

#define EN_CLR	        P5OUT &= ~BIT7           //Eõ
#define EN_SET	        P5OUT |=  BIT7           //Eø

#define PSB_CLR	        P5OUT &= ~BIT0            //PSBõͣڷʽ
#define PSB_SET	        P5OUT |=  BIT0            //PSBøߣڷʽ

#define RST_CLR	        P5OUT &= ~BIT1            //RSTõ
#define RST_SET	        P5OUT |= BIT1             //RSTø

#define DataPort        P4OUT                     //P4Ϊݿ

/*12864Ӧָ*/
#define CLEAR_SCREEN	0x01		          //ָACֵΪ00H
#define AC_INIT		0x02		          //ACΪ00HαƵԭλ
#define CURSE_ADD	0x06		          //趨αƵͼƶĬαƣͼ岻
#define FUN_MODE	0x30		          //ģʽ8λָ
#define DISPLAY_ON	0x0c		          //ʾ,ʾα꣬αλ÷
#define DISPLAY_OFF	0x08		          //ʾ
#define CURSE_DIR	0x14		          //αƶ:AC=AC+1
#define SET_CG_AC	0x40		          //ACΧΪ00H~3FH
#define SET_DD_AC	0x80                      //DDRAM AC

/*DS18B20ܽŶ*/
#define DQ_IN	        P5DIR &= ~BIT3		  //룬DS18B20ӵƬP53
#define DQ_OUT	        P5DIR |= BIT3		  //
#define DQ_CLR	        P5OUT &= ~BIT3	          //õ͵ƽ
#define DQ_SET	        P5OUT |= BIT3	          //øߵƽ
#define DQ_R	        P5IN & BIT3		  //ƽ

/*DS1302ܽŶ*/
/*DS1302λ*/
#define RESET_CLR	P6OUT &= ~BIT7            //ƽõ
#define RESET_SET	P6OUT |=  BIT7            //ƽø
#define RESET_IN	P6DIR &= ~BIT7            //
#define RESET_OUT	P6DIR |=  BIT7            //

/*DS1302˫*/
#define IO_CLR	        P6OUT &= ~BIT6            //ƽõ
#define IO_SET	        P6OUT |=  BIT6            //ƽø
#define IO_R	        P6IN & BIT6               //ƽȡ
#define IO_IN	        P6DIR &= ~BIT6            //
#define IO_OUT	        P6DIR |=  BIT6            //

/*DS1302ʱź*/
#define SCK_CLR	        P6OUT &= ~BIT5            //ʱź
#define SCK_SET	        P6OUT |=  BIT5            //ƽø
#define SCK_IN	        P6DIR &= ~BIT5            //
#define SCK_OUT	        P6DIR |=  BIT5            //

/*DS1302صַ*/
#define DS1302_sec_add		0x80		  //ݵַ
#define DS1302_min_add		0x82		  //ݵַ
#define DS1302_hr_add		0x84		  //ʱݵַ
#define DS1302_date_add		0x86		  //ݵַ
#define DS1302_month_add	0x88		  //ݵַ
#define DS1302_day_add		0x8a		  //ݵַ
#define DS1302_year_add		0x8c		  //ݵַ
#define DS1302_control_add	0x8e		  //ݵַ
#define DS1302_charger_add	0x90 					 
#define DS1302_clkburst_add	0xbe

/*I2C/EEPROMܽŶ*/
#define SCL_H P2OUT |= BIT1                       //SCLܽø
#define SCL_L P2OUT &= ~BIT1                      //SCLܽõ
#define SDA_H P2OUT |= BIT3                       //SDAܽø
#define SDA_L P2OUT &= ~BIT3                      //SDAܽõ

#define SDA_IN  P2DIR &= ~BIT3                    //SDAģʽ
#define SDA_OUT P2DIR |= BIT3                     //SDAģʽ
#define SDA_VAL P2IN&BIT3                         //SDAλֵȡ
 
#define TRUE    1
#define FALSE   0

#define EEPROMAddress 0xa0                        //AT24C16豸ַ

/*TFTܽŶ*/
#define LCD_RS0		P5OUT &= ~BIT5            //RSõ
#define LCD_RS1		P5OUT |=  BIT5            //RSø

#define LCD_WR0		P5OUT &= ~BIT6            //RWõ
#define LCD_WR1		P5OUT |=  BIT6            //RWø

#define LCD_RD0		P5OUT &= ~BIT0            //RDõ
#define LCD_RD1		P5OUT |=  BIT0            //RDø

#define LCD_EC0		P5OUT &= ~BIT7            //ECõ
#define LCD_EC1		P5OUT |=  BIT7            //ECø

#define LCD_BL0		P5OUT &= ~BIT2            //õͣ
#define LCD_BL1		P5OUT |=  BIT2            //øߣ

#define LCD_RST0	P5OUT &= ~BIT1            //RSTҺλõ
#define LCD_RST1	P5OUT |=  BIT1            //RSTҺλø


uchar   key=0xFF;                                 //ֵ
uint    temp_value;
//uint    temp,A1,A2,A3,A4;             		  //ı,ʾݴ

extern const uchar gImage_ph1[];
extern const uchar gImage_ph2[];
extern const uchar gImage_qqp[];
extern const uchar gImage_mmp[];

//***********************************************************************
//			ʾĶ
//***********************************************************************

uchar table[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,
               0x7f,0x6f,0x77,0x7c,0x39,0x5e,0x79,0x71};

//***********************************************************************
//                   ϵͳʱӳʼ
//***********************************************************************
void Clock_Init()
{
  uchar i;
  BCSCTL1&=~XT2OFF;                 //XT2
  BCSCTL2|=SELM1+SELS;              //MCLKΪ8MHZSMCLKΪ8MHZ
  do{
    IFG1&=~OFIFG;                   //־
    for(i=0;i<100;i++)
       _NOP();
  }
  while((IFG1&OFIFG)!=0);           //־λ1ѭȴ
  IFG1&=~OFIFG; 
}
//***********************************************************************
//               MSP430ڲŹʼ
//***********************************************************************
void WDT_Init()
{
   WDTCTL = WDTPW + WDTHOLD;       //رտŹ
}

//***********************************************************************
//		ر
//***********************************************************************
void Close_LED()
{
  DATASEL  = 0x00;                      //IOΪͨI/Oģʽ˾ʡ
  DATADIR  = 0xFF;                      //IOڷΪ
  DATAPORT = 0xFF;                      //P4ڳʼΪFF
  
  CTRSEL  =  0x00;                      //IOΪͨI/Oģʽ˾ʡ
  CTRDIR |=  BIT3 + BIT4;               //IOڷΪ,ƿP63,P64
  CTRPORT =  0xFF;                      //P6ڳʼΪFF  
  
  DCTR1;                                //صܣʾ                   
  WCTR1;                     
  DATAPORT=0xFF;                        //            
  WCTR0; 
}